/******************************************************************************
*******************************************************************************

	Space Impakto DS
	relminator
	http://rel.betterwebber.com


	Cspline class


*******************************************************************************
******************************************************************************/

/*
 *	Fixed Point spline alpha
 *	relminator
 *	http://rel.betterwebber.com
 *
 */
 
#include <nds.h>

#ifndef Cspline__H
#define Cspline__H

#define LIMIT_SPLINE_TIMER(tval) ( ((tval) & 4095) ) 
#define SPLINE_MAX_POINTS 10

#ifndef __Tcoord
#define __Tcoord

	struct Tcoord
	{
		int		x;
		int		y;
	};

#endif


class Cspline
{
	public:
	
	Cspline();
	~Cspline();

	
	inline Tcoord p(int idx);
	
	//methods
	void init_coords(int max_points);
	void update();

	int		x;
	int		y;
	
	s32		tval;
	s32		speed;
	int		index;
	int		max_index;
	
	Tcoord	*p_coords;
	
	private:
	
	
	
	
};


/******************************************************************************


******************************************************************************/
inline Tcoord Cspline::p(int idx)
{
	if (idx < 0)
		idx = 0;
		
	if (idx >= max_index)
		idx = max_index-1;
		
	
	return p_coords[idx];
}



#endif
